#!/bin/sh

mem=$[`grep MemTotal /proc/meminfo | sed 's/[^0-9]//g'`*2]
[ -n "$mem" ] || mem=0

# if < 4Gb then swap is mem * 2, otherwize mem * 1.5
if [ $mem -ge 8388608 ]; then
	swap_size=$[$mem*3/2]
else
	swap_size=$[$mem*2]
fi

max_disk=$(cat /sys/block/{hd,sd,vd,nvme,mmcblk}*/size 2>/dev/null | sort -n -r | head -1)
[ -n "$max_disk" ] || max_disk=0

# 32Gb
[ $swap_size -ge 67108864 ] && swap_size=67108864

common() {
cat << _EOF_
  (action . trivial)
  (actiondata
_EOF_
if [ `arch` = 'e2k' ]; then
# see also http://bugzilla.altlinux.org/34600
cat << _EOF_
   ("/boot" (size 2097152 . 2097152 ) (fsim . "Ext4") (methods plain))
_EOF_
fi
}

{
cat << _EOF_
((workstation
_EOF_
# less them 120G
# / is whole disk
if [ "$max_disk" -le 251658240 ] ; then
	swap_size=$[$mem]
	cat << _EOF_
  (title . "Setup for workstation")
_EOF_
common
cat << _EOF_
   ("swap" (size $swap_size . $swap_size) (fsim . "SWAPFS") (methods plain))
   ("/" (size 21000000 . #t ) (fsim . "Ext4") (methods plain))))
_EOF_
# less them 500G
# / is 25Gb
elif [ "$max_disk" -le 1048576000 ] ; then
	cat << _EOF_
  (title . "Setup for workstation")
_EOF_
common
cat << _EOF_
   ("swap" (size $swap_size . $swap_size) (fsim . "SWAPFS") (methods plain))
   ("/" (size 52428800 . 52428800 ) (fsim . "Ext4") (methods plain))
   ("/home" (size 21000000 . #t) (fsim . "Ext4") (methods  plain))))
_EOF_
else
# / is 40Gb
	cat << _EOF_
  (title . "Setup for workstation")
_EOF_
common
cat << _EOF_
   ("swap" (size $swap_size . $swap_size) (fsim . "SWAPFS") (methods plain))
   ("/" (size 84000000 . 84000000 ) (fsim . "Ext4") (methods plain))
   ("/home" (size 21000000 . #t) (fsim . "Ext4") (methods  plain))))
_EOF_
fi
# If btrfs-progs installed then add btrrf profile (with subvolumes for timeshift)
if [ -x /sbin/mkfs.btrfs ]; then
cat << _EOF_
(workstation-btrfs
  (title . "Setup for workstation (BtrFS)")
_EOF_
common
cat << _EOF_
   ("swap" (size . $swap_size) (fsim . "SWAPFS") (methods plain))
   ("" (size 21000000 . #t ) (fsim . "BtrFS") (methods plain)
   (subvols ("@" . "/") ("@home" . "/home")))))
_EOF_
fi
cat << _EOF_
)
_EOF_
} > /var/cache/alterator/vm-profile.scm
